Index: third_party/protobuf/objectivec/DevTools/compile_testing_protos.sh |
diff --git a/third_party/protobuf/objectivec/DevTools/compile_testing_protos.sh b/third_party/protobuf/objectivec/DevTools/compile_testing_protos.sh |
index d7f3f60589f3e42ebe1ac12ba51a7334d342b327..82953130c967ee6a03ba133ff56f46c24efbad2c 100755 |
--- a/third_party/protobuf/objectivec/DevTools/compile_testing_protos.sh |
+++ b/third_party/protobuf/objectivec/DevTools/compile_testing_protos.sh |
@@ -1,16 +1,17 @@ |
-#!/bin/bash -eu |
+#!/bin/bash |
+ |
# Invoked by the Xcode projects to build the protos needed for the unittests. |
+set -eu |
+ |
readonly OUTPUT_DIR="${PROJECT_DERIVED_FILE_DIR}/protos" |
-# ----------------------------------------------------------------------------- |
# Helper for bailing. |
die() { |
echo "Error: $1" |
exit 2 |
} |
-# ----------------------------------------------------------------------------- |
# What to do. |
case "${ACTION}" in |
"") |
@@ -25,19 +26,12 @@ case "${ACTION}" in |
;; |
esac |
-# ----------------------------------------------------------------------------- |
-# Ensure the output dir exists |
-mkdir -p "${OUTPUT_DIR}/google/protobuf" |
- |
-# ----------------------------------------------------------------------------- |
-# Move to the top of the protobuf directories and ensure there is a protoc |
-# binary to use. |
+# Move to the top of the protobuf directories. |
cd "${SRCROOT}/.." |
+ |
[[ -x src/protoc ]] || \ |
die "Could not find the protoc binary; make sure you have built it (objectivec/DevTools/full_mac_build.sh -h)." |
-# ----------------------------------------------------------------------------- |
-# See the compiler or proto files have changed. |
RUN_PROTOC=no |
if [[ ! -d "${OUTPUT_DIR}" ]] ; then |
RUN_PROTOC=yes |
@@ -56,7 +50,7 @@ else |
# Find the oldest output file. |
readonly OldestOutput=$(find \ |
"${OUTPUT_DIR}" \ |
- -type f -name "*pbobjc.[hm]" -print0 \ |
+ -type f -print0 \ |
| xargs -0 stat -f "%m %N" \ |
| sort -n -r | tail -n1 | cut -f2- -d" ") |
# If the newest input is newer than the oldest output, regenerate. |
@@ -70,30 +64,10 @@ if [[ "${RUN_PROTOC}" != "yes" ]] ; then |
exit 0 |
fi |
-# ----------------------------------------------------------------------------- |
-# Prune out all the files from previous generations to ensure we only have |
-# current ones. |
-find "${OUTPUT_DIR}" \ |
- -type f -name "*pbobjc.[hm]" -print0 \ |
- | xargs -0 rm -rf |
- |
-# ----------------------------------------------------------------------------- |
-# Helper to invoke protoc |
-compile_protos() { |
- src/protoc \ |
- --objc_out="${OUTPUT_DIR}/google/protobuf" \ |
- --proto_path=src/google/protobuf/ \ |
- --proto_path=src \ |
- "$@" |
-} |
- |
-# ----------------------------------------------------------------------------- |
-# Generate most of the proto files that exist in the C++ src tree. Several |
-# are used in the tests, but the extra don't hurt in that they ensure ObjC |
-# sources can be generated from them. |
+# Ensure the output dir exists |
+mkdir -p "${OUTPUT_DIR}/google/protobuf" |
CORE_PROTO_FILES=( |
- src/google/protobuf/any_test.proto |
src/google/protobuf/unittest_arena.proto |
src/google/protobuf/unittest_custom_options.proto |
src/google/protobuf/unittest_enormous_descriptor.proto |
@@ -116,34 +90,35 @@ CORE_PROTO_FILES=( |
src/google/protobuf/map_lite_unittest.proto |
src/google/protobuf/map_proto2_unittest.proto |
src/google/protobuf/map_unittest.proto |
- # The unittest_custom_options.proto extends the messages in descriptor.proto |
- # so we build it in to test extending in general. The library doesn't provide |
- # a descriptor as it doesn't use the classes/enums. |
+) |
+ |
+# The unittest_custom_options.proto extends the messages in descriptor.proto |
+# so we build it in to test extending in general. The library doesn't provide |
+# a descriptor as it doesn't use the classes/enums. |
+CORE_PROTO_FILES+=( |
src/google/protobuf/descriptor.proto |
) |
-# Note: there is overlap in package.Message names between some of the test |
-# files, so they can't be generated all at once. This works because the overlap |
-# isn't linked into a single binary. |
+compile_proto() { |
+ src/protoc \ |
+ --objc_out="${OUTPUT_DIR}/google/protobuf" \ |
+ --proto_path=src/google/protobuf/ \ |
+ --proto_path=src \ |
+ $* |
+} |
+ |
for a_proto in "${CORE_PROTO_FILES[@]}" ; do |
- compile_protos "${a_proto}" |
+ compile_proto "${a_proto}" |
done |
-# ----------------------------------------------------------------------------- |
-# Generate the Objective C specific testing protos. |
-compile_protos \ |
- --proto_path="objectivec/Tests" \ |
- objectivec/Tests/unittest_cycle.proto \ |
- objectivec/Tests/unittest_deprecated.proto \ |
- objectivec/Tests/unittest_deprecated_file.proto \ |
- objectivec/Tests/unittest_extension_chain_a.proto \ |
- objectivec/Tests/unittest_extension_chain_b.proto \ |
- objectivec/Tests/unittest_extension_chain_c.proto \ |
- objectivec/Tests/unittest_extension_chain_d.proto \ |
- objectivec/Tests/unittest_extension_chain_e.proto \ |
- objectivec/Tests/unittest_extension_chain_f.proto \ |
- objectivec/Tests/unittest_extension_chain_g.proto \ |
- objectivec/Tests/unittest_runtime_proto2.proto \ |
- objectivec/Tests/unittest_runtime_proto3.proto \ |
- objectivec/Tests/unittest_objc.proto \ |
+OBJC_PROTO_FILES=( |
+ objectivec/Tests/unittest_cycle.proto |
+ objectivec/Tests/unittest_runtime_proto2.proto |
+ objectivec/Tests/unittest_runtime_proto3.proto |
+ objectivec/Tests/unittest_objc.proto |
objectivec/Tests/unittest_objc_startup.proto |
+) |
+ |
+for a_proto in "${OBJC_PROTO_FILES[@]}" ; do |
+ compile_proto --proto_path="objectivec/Tests" "${a_proto}" |
+done |